unit UCompte;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, Menus, ComCtrls, UCalc, UBravo, UProp, XPMan;

type
  TLeCompteFrm = class(TForm)
    MainPnl: TPanel;
    ResultatLbl: TLabel;
    MainMenu1: TMainMenu;
    Fichier1: TMenuItem;
    Nouveau1: TMenuItem;
    N1: TMenuItem;
    Quitter1: TMenuItem;
    Montrerlaide1: TMenuItem;
    CalcTimer: TTimer;
    TempsLbl: TLabel;
    PageControl: TPageControl;
    CalculsSheet: TTabSheet;
    SolutionsSheet: TTabSheet;
    CalcPnl: TPanel;
    SolutionLbl: TLabel;
    CalcProgressBar: TProgressBar;
    TimeProgressBar: TProgressBar;
    SolNavigPnl: TPanel;
    CalcTimeLbl: TLabel;
    Proposeruncompte1: TMenuItem;
    SolTimer: TTimer;
    XPManifest1: TXPManifest;
    NouveauCompteBtn: TButton;
    Nombre1Btn: TButton;
    Nombre2Btn: TButton;
    Nombre3Btn: TButton;
    Nombre5Btn: TButton;
    Nombre4Btn: TButton;
    Nombre6Btn: TButton;
    Res1Btn: TButton;
    Res2Btn: TButton;
    Res3Btn: TButton;
    Res4Btn: TButton;
    Res5Btn: TButton;
    Op1Edt: TEdit;
    Op2Edt: TEdit;
    Op3Edt: TEdit;
    Op4Edt: TEdit;
    Op5Edt: TEdit;
    AideEdt: TEdit;
    RAZBtn: TBitBtn;
    GommeBtn: TBitBtn;
    PlusBtn: TBitBtn;
    MoinsBtn: TBitBtn;
    MultBtn: TBitBtn;
    DivBtn: TBitBtn;
    SolPrecBtn: TBitBtn;
    SolSuivBtn: TBitBtn;
    NbSolEdt: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure RAZBtnClick(Sender: TObject);
    procedure GommeBtnClick(Sender: TObject);
    procedure NouveauCompteBtnClick(Sender: TObject);
    procedure ValiderOperation;
    procedure NombreBtnClick(Sender: TObject);
    procedure OpBtnClick(Sender: TObject);
    procedure Quitter1Click(Sender: TObject);
    procedure Montrerlaide1Click(Sender: TObject);
    procedure CalcTimerTimer(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure WaitSolutions(Sender: TObject);
    procedure SolNavigBtnClick(Sender: TObject);
    procedure Proposeruncompte1Click(Sender: TObject);
    procedure SolTimerTimer(Sender: TObject);
  Private
    { Dclarations prives}
  Public
    { Dclarations publiques}
  end;

  TEtapeOp = (AskNb1, AskOp, AskNb2);
  TUneOperation = record
    OutEdt: TEdit;
    OutBtn: TButton;
    Etape: TEtapeOp;
    n1: string[8];
    n2: string[8];
    op: string[1];
    res: string[8];
    n1Btn: TButton;
    n2Btn: TButton;
  end;

var
  LeCompteFrm: TLeCompteFrm;
  CalcThread: TCalcThread;
  AOperations: array[1..5] of TUneOperation;
  OpEnCours: Byte;
  CalcTps: SmallInt; // tps en dixiemes de sec
  SolTps: SmallInt;
  SolList: TStringList;
  SolCour: Integer;

const
  PLUSSTR = '+';
  MOINSSTR = '-';
  MULTSTR = 'x';
  DIVSTR = '/';
  TIMEMAX = 500;

implementation

{$R *.DFM}

//-----------------------------------------------------------

function DecompositionEnFacteursPremiers(nb: Word): string;
var n, m, j: integer;
  chaine01: string;
label A, B;
begin
  chaine01 := ''; n := 2;
  A: if (int(nb / n) = nb / n) then
  begin
    chaine01 := chaine01 + 'x' + IntToStr(n);
    nb := round(int(nb / n));
    goto A;
  end;
  inc(n);
  if (n <= 3) then goto A;
  n := 5;
  m := 2;
  j := -2;
  B: if (int(nb / n) = nb / n) then
  begin
    chaine01 := chaine01 + 'x' + IntToStr(n);
    nb := round(int(nb / n));
    goto B;
  end;
  inc(n, m);
  j := -j;
  inc(m, j);
  if (n > round(sqr(nb))) then
    if (nb <> 1) then chaine01 := chaine01 + ' x ' + IntToStr(n);
  if (n <= round(sqr(nb))) then goto B;
  Result := copy(chaine01, 2, length(chaine01) - 1);
end;

//-------------------------------------------------

procedure TLeCompteFrm.FormCreate(Sender: TObject);
begin
  Randomize;
  AOperations[1].OutEdt := Op1Edt;
  AOperations[1].OutBtn := Res1Btn;
  AOperations[1].Etape := AskNb1;
  AOperations[2].OutEdt := Op2Edt;
  AOperations[2].OutBtn := Res2Btn;
  AOperations[2].Etape := AskNb1;
  AOperations[3].OutEdt := Op3Edt;
  AOperations[3].OutBtn := Res3Btn;
  AOperations[3].Etape := AskNb1;
  AOperations[4].OutEdt := Op4Edt;
  AOperations[4].OutBtn := Res4Btn;
  AOperations[4].Etape := AskNb1;
  AOperations[5].OutEdt := Op5Edt;
  AOperations[5].OutBtn := Res5Btn;
  AOperations[5].Etape := AskNb1;
  SolList := TStringList.Create;
  PageControl.ActivePage := SolutionsSheet; Show; Update;
  PageControl.ActivePage := CalculsSheet; Show; Update;
  CalcThread := nil;
//  NouveauCompteBtnClick(Sender);
end;

//-------------------------------------------------

procedure TLeCompteFrm.FormResize(Sender: TObject);
var
  u, v: Word;
begin
  NouveauCompteBtn.Left := 10;
  if (MainPnl.Width - 20 > 0) then
    NouveauCompteBtn.Width := MainPnl.Width - 20
  else NouveauCompteBtn.Width := MainPnl.Width;
  ResultatLbl.Left := (MainPnl.Width - ResultatLbl.Width) div 2;
  AideEdt.Left := ResultatLbl.Left + ResultatLbl.Width + 10;
  AideEdt.Width := MainPnl.Width - AideEdt.Left - 10;
  u := MainPnl.Width div 6;
  v := u div 6;
  if (v < 1) then v := 1;
  Nombre1Btn.Width := u - 2 * v;
  Nombre2Btn.Width := u - 2 * v;
  Nombre3Btn.Width := u - 2 * v;
  Nombre4Btn.Width := u - 2 * v;
  Nombre5Btn.Width := u - 2 * v;
  Nombre6Btn.Width := u - 2 * v;
  Nombre1Btn.Left := v;
  Nombre2Btn.Left := u + v;
  Nombre3Btn.Left := 2 * u + v;
  Nombre4Btn.Left := 3 * u + v;
  Nombre5Btn.Left := 4 * u + v;
  Nombre6Btn.Left := 5 * u + v;
  u := (CalcPnl.Height - TimeProgressBar.Height) div 7;
  v := u div 12;
  if (v < 1) then v := 1;
  RAZBtn.Top := v;
  RAZbtn.Height := u - 2 * v;
  GommeBtn.Top := v;
  Gommebtn.Height := u - 2 * v;
  PlusBtn.Top := u + v;
  PlusBtn.Height := u - 2 * v;
  MoinsBtn.Top := u + v;
  MoinsBtn.Height := u - 2 * v;
  MultBtn.Top := u + v;
  MultBtn.Height := u - 2 * v;
  DivBtn.Top := u + v;
  DivBtn.Height := u - 2 * v;
  Op1Edt.Top := 2 * u + v;
  Op1Edt.Height := u - 2 * v;
  Res1Btn.Top := 2 * u + v;
  Res1Btn.Height := u - 2 * v;
  Op2Edt.Top := 3 * u + v;
  Op2Edt.Height := u - 2 * v;
  Res2Btn.Top := 3 * u + v;
  Res2Btn.Height := u - 2 * v;
  Op3Edt.Top := 4 * u + v;
  Op3Edt.Height := u - 2 * v;
  Res3Btn.Top := 4 * u + v;
  Res3Btn.Height := u - 2 * v;
  Op4Edt.Top := 5 * u + v;
  Op4Edt.Height := u - 2 * v;
  Res4Btn.Top := 5 * u + v;
  Res4Btn.Height := u - 2 * v;
  Op5Edt.Top := 6 * u + v;
  Op5Edt.Height := u - 2 * v;
  Res5Btn.Top := 6 * u + v;
  Res5Btn.Height := u - 2 * v;
  u := CalcPnl.Width div 9;
  RAZBtn.Width := 3 * u;
  RAZBtn.Left := u;
  GommeBtn.Width := 3 * u;
  GommeBtn.Left := 5 * u;
  PlusBtn.Width := u;
  PlusBtn.Left := u;
  MoinsBtn.Width := u;
  MoinsBtn.Left := 3 * u;
  MultBtn.Width := u;
  MultBtn.Left := 5 * u;
  DivBtn.Width := u;
  DivBtn.Left := 7 * u;
  u := CalcPnl.Width div 16;
  Op1Edt.Width := 9 * u;
  Op1Edt.Left := u;
  Op2Edt.Width := 9 * u;
  Op2Edt.Left := u;
  Op3Edt.Width := 9 * u;
  Op3Edt.Left := u;
  Op4Edt.Width := 9 * u;
  Op4Edt.Left := u;
  Op5Edt.Width := 9 * u;
  Op5Edt.Left := u;
  Res1Btn.Width := 4 * u;
  Res1Btn.Left := 11 * u;
  Res2Btn.Width := 4 * u;
  Res2Btn.Left := 11 * u;
  Res3Btn.Width := 4 * u;
  Res3Btn.Left := 11 * u;
  Res4Btn.Width := 4 * u;
  Res4Btn.Left := 11 * u;
  Res5Btn.Width := 4 * u;
  Res5Btn.Left := 11 * u;
end;

//--------------------------------------------------

procedure TLeCompteFrm.RAZBtnClick(Sender: TObject);
begin
  Nombre1Btn.Enabled := True;
  Nombre2Btn.Enabled := True;
  Nombre3Btn.Enabled := True;
  Nombre4Btn.Enabled := True;
  Nombre5Btn.Enabled := True;
  Nombre6Btn.Enabled := True;
  Op1Edt.Text := '';
  Op2Edt.Text := '';
  Op3Edt.Text := '';
  Op4Edt.Text := '';
  Op5Edt.Text := '';
  Res1Btn.Caption := '';
  Res2Btn.Caption := '';
  Res3Btn.Caption := '';
  Res4Btn.Caption := '';
  Res5Btn.Caption := '';
  Res1Btn.Enabled := False;
  Res2Btn.Enabled := False;
  Res3Btn.Enabled := False;
  Res4Btn.Enabled := False;
  Res5Btn.Enabled := False;
  OpEnCours := 1;
end;

//----------------------------------------------------

procedure TLeCompteFrm.GommeBtnClick(Sender: TObject);
begin
  if (AOperations[OpEnCours].Etape <> AskNb1) then
    with AOperations[OpEnCours] do
    begin
      Etape := AskNb1;
      OutEdt.Text := '';
      OutBtn.Caption := '';
      OutBtn.Enabled := False;
      if (n1Btn <> nil) then n1Btn.Enabled := True;
      if (n2Btn <> nil) then n2Btn.Enabled := True;
    end
  else if (OpEnCours > 1) then
    with AOperations[OpEnCours - 1] do
    begin
      Etape := AskNb1;
      OutEdt.Text := '';
      OutBtn.Caption := '';
      OutBtn.Enabled := False;
      if (n1Btn <> nil) then n1Btn.Enabled := True;
      if (n2Btn <> nil) then n2Btn.Enabled := True;
      dec(OpEnCours);
    end
end;

//------------------------------------------------------------

procedure TLeCompteFrm.NouveauCompteBtnClick(Sender: TObject);
const
  ARandNumber: array[-1..13] of string[3] = ('0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '10',
    '25', '50', '75', '100');
var
  ANbUtilises: array[0..13] of Byte;
  i: Byte;
  Tab: TArray;
  //fonction qui renvoie un nombre aleatoire.
  function Rand: Byte;
  var
    Num: Byte;
    Valid: Boolean;
  begin
    repeat
      Valid := true;
      Num := random(14);
      if ((Num > 10) and (ANbUtilises[Num] > 0)) then
        Valid := false;
      if (ANbutilises[Num] > 1) then Valid := false;
    until Valid;
    Inc(ANbutilises[Num]);
    Result := Num;
  end;
begin
  for i := 0 to 13 do ANbUtilises[i] := 0;
  RAZBtnClick(Sender);
  Nombre1Btn.Caption := ARandNumber[Rand];
  Nombre2Btn.Caption := ARandNumber[Rand];
  Nombre3Btn.Caption := ARandNumber[Rand];
  Nombre4Btn.Caption := ARandNumber[Rand];
  Nombre5Btn.Caption := ARandNumber[Rand];
  Nombre6Btn.Caption := ARandNumber[Rand];
  ResultatLbl.Caption := ARandNumber[random(9)] + ARandNumber[random(10) - 1] + ARandNumber[random(10) - 1];
  Nombre1Btn.Enabled := True;
  Nombre2Btn.Enabled := True;
  Nombre3Btn.Enabled := True;
  Nombre4Btn.Enabled := True;
  Nombre5Btn.Enabled := True;
  Nombre6Btn.Enabled := True;
  AideEdt.Text := DecompositionEnFacteursPremiers(StrToInt(ResultatLbl.Caption));
  TempsLbl.Caption := IntToStr(TIMEMAX div 10);
  TimeProgressBar.Max := TIMEMAX;
  TimeProgressBar.Position := 0;
  TimeProgressBar.Step := 1;
  CalcTps := TIMEMAX;
  SolTps := 0;
  CalcTimer.Enabled := True;
  SolTimer.Enabled := True;
  Tab[1] := StrToInt(Nombre1Btn.Caption);
  Tab[2] := StrToInt(Nombre2Btn.Caption);
  Tab[3] := StrToInt(Nombre3Btn.Caption);
  Tab[4] := StrToInt(Nombre4Btn.Caption);
  Tab[5] := StrToInt(Nombre5Btn.Caption);
  Tab[6] := StrToInt(Nombre6Btn.Caption);
  if (CalcThread <> nil) then
  begin
    CalcThread.Terminate;
    CalcThread.WaitFor;
  end;
  CalcThread := TCalcThread.Create(Tab, StrToInt(ResultatLbl.Caption), SolList, CalcProgressBar);
  CalcThread.OnTerminate := WaitSolutions;
  SolutionLbl.Caption := 'searching solutions ...';
  SolPrecBtn.Enabled := False;
  SolSuivBtn.Enabled := False;
  CalcTimeLbl.Caption := '';
  NbSolEdt.Text := '';
end;

//--------------------------------------

procedure TLeCompteFrm.ValiderOperation;
begin
  with AOperations[OpEnCours] do
  begin
    if (Op = PLUSSTR) then res := IntToStr(StrToInt(n1) + StrToInt(n2))
    else if (Op = MOINSSTR) then
    begin
      res := IntToStr(StrToInt(n1) - StrToInt(n2));
      if (StrToInt(res) < 0) then
      begin
        OutEdt.Text := n2 + op + n1;
        res := IntToStr(StrToInt(n2) - StrToInt(n1));
      end;
    end
    else if (Op = MULTSTR) then res := IntToStr(StrToInt(n1) * StrToInt(n2))
    else if (Op = DIVSTR) then
    begin
      res := IntToStr(Round(StrToInt(n1) / StrToInt(n2)));
      if (StrToInt(res) * StrToInt(n2) <> StrToInt(n1)) then
      begin
        Etape := AskNb1;
        OutEdt.Text := '';
        n1Btn.Enabled := True;
        n2Btn.Enabled := True;
        Exit;
      end;
    end;
    OutBtn.caption := res;
    OutBtn.Enabled := True;
    if (res = ResultatLbl.Caption) then
    begin
      CalcTimer.Enabled := False;
      with TBravoDlg.Create(Self) do
      try
        ShowModal;
      finally
        Free;
      end;
    end;
    inc(OpEnCours);
  end;
end;

//-----------------------------------------------------

procedure TLeCompteFrm.NombreBtnClick(Sender: TObject);
var
  b: TButton;
begin
  PageControl.ActivePage := CalculsSheet;
  if (((AOperations[OpEnCours].Etape = AskNb1) or (AOperations[OpEnCours].Etape = AskNb2)) and (OpEnCours < 6)) then
  begin
    if (Sender = Nombre1Btn) then b := Nombre1Btn
    else if (Sender = Nombre2Btn) then b := Nombre2Btn
    else if (Sender = Nombre3Btn) then b := Nombre3Btn
    else if (Sender = Nombre4Btn) then b := Nombre4Btn
    else if (Sender = Nombre5Btn) then b := Nombre5Btn
    else if (Sender = Nombre6Btn) then b := Nombre6Btn
    else if (Sender = Res1Btn) then b := Res1Btn
    else if (Sender = Res2Btn) then b := Res2Btn
    else if (Sender = Res3Btn) then b := Res3Btn
    else if (Sender = Res4Btn) then b := Res4Btn
    else if (Sender = Res5Btn) then b := Res5Btn
    else exit;
    b.Enabled := False;
    with AOperations[OpEnCours] do
      case Etape of
        AskNb1: begin
            n1 := b.Caption;
            OutEdt.Text := n1;
            Etape := AskOp;
            n1Btn := b;
          end;
        AskNb2: begin
            n2 := b.Caption;
            OutEdt.Text := n1 + op + n2;
            Etape := AskNb1;
            n2Btn := b;
            ValiderOperation;
          end;
      end;
  end;
  ActiveControl := CalcPnl;
end;

//-------------------------------------------------

procedure TLeCompteFrm.OpBtnClick(Sender: TObject);
begin
  if (OpEnCours < 6) then with AOperations[OpEnCours] do
      if ((Etape = AskOp) or ((Etape = AskNb1) and (OpEnCours > 1))) then
      begin
        if ((Etape = AskNb1) and (OpEnCours > 1)) then
        begin
          n1 := AOperations[OpEnCours - 1].OutBtn.Caption;
          n1Btn := AOperations[OpEnCours - 1].OutBtn;
          n1Btn.Enabled := False;
        end;
        if (Sender = PlusBtn) then op := PLUSSTR
        else if (Sender = MoinsBtn) then op := MOINSSTR
        else if (Sender = MultBtn) then op := MULTSTR
        else if (Sender = DivBtn) then op := DIVSTR
        else exit;
        Etape := AskNb2;
        OutEdt.Text := n1 + op;
      end;
end;

//----------------------------------------------------

procedure TLeCompteFrm.Quitter1Click(Sender: TObject);
begin
  Close;
end;

//--------------------------------------------------

procedure TLeCompteFrm.Proposeruncompte1Click(Sender: TObject);
var
  Tab: TArray;
begin
  with TPropositionDlg.Create(Self) do
  try
    ShowModal;
    if (ModalResult = mrOk) then
    begin
      RAZBtnClick(Sender);
      Nombre1Btn.Caption := Nb1Edt.Text;
      Nombre2Btn.Caption := Nb2Edt.Text;
      Nombre3Btn.Caption := Nb3Edt.Text;
      Nombre4Btn.Caption := Nb4Edt.Text;
      Nombre5Btn.Caption := Nb5Edt.Text;
      Nombre6Btn.Caption := Nb6Edt.Text;
      ResultatLbl.Caption := ResEdt.Text;
      Nombre1Btn.Enabled := True;
      Nombre2Btn.Enabled := True;
      Nombre3Btn.Enabled := True;
      Nombre4Btn.Enabled := True;
      Nombre5Btn.Enabled := True;
      Nombre6Btn.Enabled := True;
      TempsLbl.Caption := '0';
      TimeProgressBar.Position := 0;
      CalcTps := 0;
      SolTps := 0;
      CalcTimer.Enabled := False;
      SolTimer.Enabled := True;
      Tab[1] := StrToInt(Nombre1Btn.Caption);
      Tab[2] := StrToInt(Nombre2Btn.Caption);
      Tab[3] := StrToInt(Nombre3Btn.Caption);
      Tab[4] := StrToInt(Nombre4Btn.Caption);
      Tab[5] := StrToInt(Nombre5Btn.Caption);
      Tab[6] := StrToInt(Nombre6Btn.Caption);
      if (CalcThread <> nil) then
      begin
        CalcThread.Terminate;
        CalcThread.WaitFor;
      end;
      CalcThread := TCalcThread.Create(Tab, StrToInt(ResultatLbl.Caption), SolList, CalcProgressBar);
      CalcThread.OnTerminate := WaitSolutions;
      SolutionLbl.Caption := 'searching solutions ...';
      CalcTimeLbl.Caption := '';
      NbSolEdt.Text := '';
    end;
    PageControl.ActivePage := SolutionsSheet;
  finally
    Free;
  end;
end;

//---------------------------------------------------------

procedure TLeCompteFrm.Montrerlaide1Click(Sender: TObject);
begin
  Montrerlaide1.Checked := not (Montrerlaide1.Checked);
  AideEdt.Visible := Montrerlaide1.Checked;
end;

//--------------------------------------------------

procedure TLeCompteFrm.CalcTimerTimer(Sender: TObject);
begin
  Dec(CalcTps);
  if (CalcTps mod 10 = 0) then TempsLbl.Caption := IntToStr(CalcTps div 10);
  TimeProgressBar.StepIt;
  if (CalcTps < 1) then CalcTimer.Enabled := False;
end;

//--------------------------------------------------

procedure TLeCompteFrm.SolTimerTimer(Sender: TObject);
begin
  Inc(SolTps);
end;

//--------------------------------------------------

procedure TLeCompteFrm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key in [008, 027, 106, 107, 109, 111]) then PageControl.ActivePage := CalculsSheet;
  case Key of
    107: OpBtnClick(PlusBtn); //'+'
    109: OpBtnClick(MoinsBtn); //'-'
    106: OpBtnClick(MultBtn); //'*'
    111: OpBtnClick(DivBtn); //'/'
    008: GommeBtnClick(GommeBtn); //backspace
    027: RAZBtnClick(RAZBtn); //escape
  end;
end;

//--------------------------------------------------

procedure TLeCompteFrm.WaitSolutions(Sender: TObject);
begin
  if (SolList.Count > 0) then
  begin
    SolCour := 1;
    SolutionLbl.Caption := SolList[0];
    NbSolEdt.Text := IntToStr(SolCour) + ' / ' + IntToStr(SolList.Count);
    SolPrecBtn.Enabled := True;
    SolSuivBtn.Enabled := True;
  end
  else begin
    SolutionLbl.Caption := 'no solution';
    NbSolEdt.Text := '0 / 0';
    SolPrecBtn.Enabled := False;
    SolSuivBtn.Enabled := False;
  end;
  CalcTimeLbl.Caption := IntToStr(SolTps div 10) + '.' + IntToStr(SolTps mod 10) + ' sec';
end;

//--------------------------------------------------

procedure TLeCompteFrm.SolNavigBtnClick(Sender: TObject);
begin
  if (Sender = SolPrecBtn) then
    if (SolCour = 1) then SolCour := SolList.Count
    else Dec(SolCour)
  else if (Sender = SolSuivBtn) then
    if (SolCour = SolList.Count) then SolCour := 1
    else Inc(SolCour)
  else Exit;
  NbSolEdt.Text := IntToStr(SolCour) + ' / ' + IntToStr(SolList.Count);
  SolutionLbl.Caption := SolList[SolCour - 1];
end;

//--------------------------------------------------

end.

